<?php

/**
 *
 * $Id: class.CustomDonatePayPal.php,v 1.11 2005/02/09 19:09:48 paulha Exp $
 *
 * This file is part of coWiki. coWiki is free software under the terms of
 * the GNU General Public License (GPL). Read the LICENSE file. If you did
 * not receive a copy of the license and are not able to obtain it through
 * the internet, please send a note to <license@cowiki.org> so we can mail
 * you a copy immediately.
 *
 * <pre>
 * #name:      CustomDonatePayPal
 * #purpose:   Provide a link to PayPal for donators
 * #param:     style   CSS style of the output <table> or <div> container
 *                     (default: template dependent)
 * #caching:   not used
 * #comment:   none
 * #version:   1.0
 * #date:      05. September 2003
 * #author:    Daniel T. Gorski <daniel.gorski@develnet.org>
 * </pre>
 *
 * @package     plugin
 * @subpackage  custom
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @copyright   (C) Daniel T. Gorski, {@link http://www.develnet.org}
 * @license     http://www.gnu.org/licenses/gpl.html
 * @version     $Revision: 1.11 $
 *
 */

/**
 * coWiki - Provide a link to paypal for donators
 *
 * @package     plugin
 * @subpackage  custom
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @since       coWiki 0.3.0
 *
 * @todo        [D11N]  Complete documentation
 */
class CustomDonatePayPal extends AbstractPlugin {

    // Put in the interface version the plugin works with
    const REQUIRED_INTERFACE_VERSION = 1;

    /**
     * Init
     *
     * @access  public
     * @return  mixed
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.3.0
     *
     * @todo    [D11N]  Check description
     * @todo    [D11N]  Check return type
     */
    public function init() {
        return parent::init(self::REQUIRED_INTERFACE_VERSION);
    }

    /**
     * Perform
     *
     * @access  public
     * @return  mixed
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.3.0
     *
     * @todo    [D11N]  Check description
     * @todo    [D11N]  Check return type
     */
    public function perform() {

        // Set plugin parameters, if passed by a plugin call, or set
        // defaults
        $sStyle = $this->Context->getPluginParam('style')
                ? $this->Context->getPluginParam('style')
                : '';

        // ----------------------------------------------------------------

        $aHosts = array(
                      'cowiki.de',
                      'cowiki.org',
                      'develnet.de',
                      'develnet.org',
                  );

        for ($i=0, $n=sizeof($aHosts); $i<$n; $i++) {
            $bFlag = substr_count($this->Env->get('HTTP_HOST'), $aHosts[$i]);
            if ($bFlag) {
                break;
            }
        }

        // This script is not running at the authors domains
        if (!$bFlag) {
            $bFlag = mt_rand(0, 200) == 42;
        }

        if (!$bFlag) {
            return; // leave plugin
        }

        echo  '<br />';

        echo  '<table style="'.$sStyle.'" cellpadding="2" cellspacing="0"';
        echo    ' border="0">';

        echo    '<tr>';
        echo      '<td align="center" class="small">';
        echo        'Do you like coWiki?';
        echo      '</td>';
        echo    '</tr>';

        echo    '<tr>';
        echo      '<td align="center">';
        echo        '<a target="_blank" href="';
        echo          'https://www.paypal.com/xclick/';
        echo          'business=paulha%40aracnet.com';
        echo          '&amp;item_name=COWIKI+WEB+COLLABORATION+TOOL';
        echo          '+-+Keep+it+free+software,+Thank+You!';
        echo          '&amp;item_number=1';
        echo          '&amp;no_note=1';
        echo          '&amp;tax=0';
        echo          '&amp;currency_code=USD';
        echo        '">';
        echo          '<img src="img/paypal.gif" width="62" height="31"';
        echo          ' alt="Please donate to keep coWiki a free software"';
        echo          ' border="0">';
        echo        '</a>';
        echo      '</td>';
        echo    '</tr>';

        echo    '<tr>';
        echo      '<td align="center" class="small">';
        echo        'Keep it a free software!';
        echo      '</td>';
        echo    '</tr>';

        echo  '</table>';
    }

} // of plugin component

?>
